<?php
$title="Getting Data From Another HTML Page with Ajax and Gears ";
$background="images/art038.jpg";
$description="";
include("header.php");
include("sidebar.php");
?>

<div id="content">

        
  <h1>Getting Data From Another HTML Page with Ajax and Gears </h1>
        
  <p> Ajax Gears allows to load an HTML page on the same site, or locally when offline, extract data from this other  page and display the extracted data into the current page. </p>
  <p>The demo actually takes a table that holds the list of Anaa Gear's functions, and adds the table into the demo page. </p>
  <h2>How to use the demo </h2>
  <ol>
    <li>Load the demo page.</li>
    <li>Go offline by a click on the first button. </li>
    <li>You can now close the Internet connection and load this page again</li>
    <li>Click on &quot;submit&quot; to try the demo without connection. </li>
  </ol>
  <h2>How it works</h2>
  <p>This makes use of a special function of Anaa Gears, AALoadHTML, that loads a page as a text file, stores it into a &lt;div&gt; in the calling page and uses DOM's methods to get tags inside the &lt;div&gt;.</p>
  <h3>The structure of the Gears page</h3>
  <p>These fields are required (the name is the ID of a &lt;div&gt; tag:  </p>
  <ul>
    <li>textOut: Displays Gears message. Manage it as you want.</li>
    <li>storage: The content of the other HTML page is stored here. Of course it is not displayed.<br>
    &lt;div id=&quot;storage&quot; style=&quot;display:none;&quot;&gt;
    &lt;/div&gt;</li>
    <li>  viewed: The data extracted from the other page are stored here and displayed. <br />
    </li>
  </ul>
  <h3>The buttons</h3>
  <p>Go offline: Allows to view the page without connection.<br>
    Return online: Synchronizes the content on the server with the local version.<br>
    Submit: Add the content of another HTML page to the demo page.   </p>
  <pre> &lt;button onClick=&quot;createStore()&quot;&gt; Go offline &lt;/button&gt;
 &lt;button onClick=&quot;removeStore()&quot;&gt; Return online &lt;/button&gt;
 &lt;button onClick=&quot;submitForm('anaa-gears-functions.html', 'storage', 'viewed')&quot;&gt;Submit&lt;/button&gt;</pre>
  <h3>The scripts</h3>
  <p>These scripts are required:</p>
  <pre>&lt;script src=&quot;gears_init.js&quot;&gt;<br>&lt;script src=&quot;gears_offline.js&quot;&gt;<br>&lt;script src=&quot;anaa-gears.js&quot;&gt;<br>&lt;script src=&quot;demo-html.js&quot;&gt;</pre>
  <p>The <a href="code/demo-html.txt" target="_parent">demo-html.js</a> file holds two functions:</p>
  <p><em>submitForm</em> is called by the submit button.</p>
  <p>    <em>processHTML</em> is passed as parameter to the Ajax method <em>AALoadHTML</em>, its purpose is to process the file once loaded (another HTML page),  to extract its content and put it into the current page. </p>
  <pre>MANIFEST_FILENAME = &quot;demo-gears-get-html.json&quot;;

function processHTML(storage, viewedID)
{
     var z = storage.getElementsByTagName(&quot;table&quot;).item(0).innerHTML;
     var target = document.getElementById(viewedID);
     target.innerHTML =  &quot;&lt;table&gt;&quot; + z + &quot;&lt;/table&gt;&quot;;
}

function submitForm(url, storageID, viewedID)
{ 
     var y = AALoadHTML(url, processHTML, storageID, viewedID);
}
window.onload=init;   // starts Gears</pre>
  <h2>The manifest file</h2>
  <p>This file tells to Gears which files have to be stored locally:   </p>
  <pre>{
 &quot;betaManifestVersion&quot;: 1,
 &quot;version&quot;: &quot;1.0&quot;,
 &quot;entries&quot;: [
 { &quot;url&quot;: &quot;demo-gears-get-html.html&quot;},
 { &quot;url&quot;: &quot;gears_offline.js&quot;},
 { &quot;url&quot;: &quot;gears_init.js&quot;},
 { &quot;url&quot;: &quot;anaa-gears.js&quot;},
 { &quot;url&quot;: &quot;demo-html.js&quot;},
 { &quot;url&quot;: &quot;demo-html.txt&quot;},
 { &quot;url&quot;: &quot;anaa-gears-functions.html&quot;}
 ]
}</pre>
  <p>The first file is the demo, the last one is the HTML page where data are taken.</p>
  <p><a href="code/demo-gears-get-html.html" target="_parent">Try the demo</a>.</p>
  <p>All the files are included in the archive of the Anaa Gears framework.   </p>
  
  
<?php include("footer.php"); ?>
